package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.Testgit;
import com.izouma.awesomeadmin.service.TestgitService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/testgit")
public class TestgitController {

    @Autowired
    private TestgitService testgitService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(Testgit record) {
        List<Testgit> pp = testgitService.getTestgitList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getTestgit", method = RequestMethod.GET)
    @ResponseBody
    public Result getTestgit(@RequestParam(required = false, value = "id") String id) {
        Testgit data = testgitService.getTestgitById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(Testgit record) {
        Testgit data = testgitService.getTestgit(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, Testgit record) {
        Map<String, Object> result = new HashMap<>();

        List<Testgit> pp =testgitService.getTestgitByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(Testgit record) {
        boolean num = testgitService.createTestgit(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateTestgit(Testgit record) {
        boolean num = testgitService.updateTestgit(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteTestgit(@RequestParam(required = true, value = "id") String id) {

        boolean num = testgitService.deleteTestgit(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, Testgit record) throws Exception {

    List<Testgit> testgits = testgitService.getTestgitList(record);


        String sheetName = "test_git";
        String titleName = "testgit数据表";
        String fileName = "testgit表";
        int columnNumber = 2;
        int[] columnWidth = { 20,  20 };
        String[] columnName = {  "" ,   "删除标识"  };
        String[][] dataList = new String[testgits.size()][2];

        for (int i = 0; i < testgits.size(); i++) {

                        dataList[i][0] = String.valueOf(testgits.get(i).getId());
                        dataList[i][1] = String.valueOf(testgits.get(i).getDelFlag());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

